#-------------------------------------------------------------------------
# /etc/rc.d/rc980.uc - start user counting
#
# Creation:     10.02.2003 
# Last Update:  08.06.2003
#-------------------------------------------------------------------------
#!/bin/sh
# opt_user_count 0.9a
# prepare script, should run on boot
#set -x

if [  "$OPT_USERCOUNT_DEBUG" = "yes"  ] ; then set -x ; fi

#OPT_BASH="no" # variablen indexierung

colecho "opt_user-count prepare..." gn

# make new holder file for interessting var from rc.cfg
if [ -f /var/run/uc_hosts.cfg  ] ; then rm -rf /var/run/uc_hosts.cfg  ; fi

for i in ^HOSTNAME*  ^START_IMOND ^IMOND_LOG*  \
 ^HTTPD_DOC_ROOT ^PROXY_PORT ^OPT_PROXY ^OPT_EXTRATOOLS ^OPT_USERCOUNT* 
	do  grep $i /boot/rc.cfg >> /var/run/uc_hosts.cfg
done

. /var/run/uc_hosts.cfg

#-------------------------------------------------------------------------
# isdn circuit zu devices und einwahlgebhren erfassen
#-------------------------------------------------------------------------

#debug in
#OPT_UC_ISDN_CIRC_1_EINWKOSTEN='0.23'
#debug out

[ -f /var/run/uc_circuit.data ] && rm -f /var/run/uc_circuit.data
for i in \
 ^ISDN_CIRC_[0-9]*_BUNDLING ^ISDN_CIRC_[0-9]*_HUP_TIMEOUT ^OPT_UC_ISDN_CIRC_[0-9]*_EINWKOSTEN
	do grep $i /boot/rc.cfg >> /var/run/uc_circuit.data
done
. /var/run/uc_circuit.data && rm -f /var/run/uc_circuit.data

# jedes circuit auf bundling checken
# hchste ip nr ermitteln ( letzte zeile , 3. Feld , letztes Zeichen )
last_ippp_nr=`tail -1 /etc/imond.conf | awk '{pos=length($3) ; print substr($3,pos)}'`
y=-1 ; z=0              # y~ ippp-dev-nr     z ~ isdn-circuit
#echo "$last_ippp_nr"
until [ ${y} -eq ${last_ippp_nr} ] ; do
	y=`expr  ${y} + 1` ; z=`expr  ${z} + 1`
	# wenn bundling beide devices auf gleiche hangup time setzen z.B. ( ippp0, ippp1 )
	if [ "`eval echo \$\{ISDN_CIRC_${z}_BUNDLING\}`" = "yes" ] ; then
		anker=`eval echo \$\{ISDN_CIRC_${z}_HUP_TIMEOUT\}`
		eval ippp${y}=`expr ${anker} + 15`
		# -n ~ nicht leer
		if [ -n  "`eval echo \$\{OPT_UC_ISDN_CIRC_${z}_EINWKOSTEN\}`"  ] ; then
			eval ippp${y}_gebuehr=`eval echo \$\{OPT_UC_ISDN_CIRC_${z}_EINWKOSTEN\}`
			else eval ippp${y}_gebuehr="0.00"
		fi
		# echo / ippp device / hangup time / gebuehr /
		echo -e "ippp${y} \t `eval echo \$\{ippp${y}\}` \t `eval echo \$\{ippp${y}_gebuehr\}` " >> /var/run/uc_circuit.data
		y=`expr  ${y} + 1`
	fi
	# sonst nur das aktuelle device z.B. ( ippp0 )
	anker=`eval echo \$\{ISDN_CIRC_${z}_HUP_TIMEOUT\}`
	eval ippp${y}=`expr ${anker} + 15`
	# einwahlgbehr pro circuit erfassen
	if [ -n  "`eval echo \$\{OPT_UC_ISDN_CIRC_${z}_EINWKOSTEN\}`"  ] ; then
		eval ippp${y}_gebuehr=`eval echo \$\{OPT_UC_ISDN_CIRC_${z}_EINWKOSTEN\}`
		else eval ippp${y}_gebuehr="0.00"
	fi
	# echo / ippp device / hangup time / gebuehr /
	echo -e "ippp${y} \t `eval echo \$\{ippp${y}\}` \t `eval echo \$\{ippp${y}_gebuehr\}` " >> /var/run/uc_circuit.data
done
echo "table of known isdn devices :"
echo "-----------------------------"
echo -e "dev\thangup\teinwkosten"
cat /var/run/uc_circuit.data
echo "-----------------------------"
#-------------------------------------------------------------------------

 # eventuell nicht vorhandenen imond direktory abschluss "/" einfgen
[ `echo "${IMOND_LOGDIR}" | grep -c  '/$' `  -ne  "1"  ] && IMOND_LOGDIR="${IMOND_LOGDIR}/" && \
 	awk -F= -v inhalt=${IMOND_LOGDIR}  '
		{
   		if  (  $1 ~  /IMOND_LOGDIR/ ) {  print "IMOND_LOGDIR="inhalt  }
    		else   {  print $1"="$2  }
     		} ' /var/run/uc_hosts.cfg > /var/run/uc_hosts.cfg.sed  &&  mv  /var/run/uc_hosts.cfg.sed  /var/run/uc_hosts.cfg 	 && \
echo "directory of imond.log read and missing final \"/\" written..."

# get router mac adress for tcpdump | make a valid /etc/ethers
# if you have more than one eth cards edit below string "eth0"
# to your eth card wich is connected to your intranet like "eth1"
if [ -f /etc/ethers ]
 	then rm -rf /etc/ethers
fi
hwadress=`/sbin/ifconfig eth0 | grep eth0 | cut -c 39-56`
echo "$hwadress	$HOSTNAME" > /etc/ethers
echo "/etc/ethers created..."

# DAYLOG Directory anlegen, wenn noch nicht existent

if [  "${OPT_USERCOUNT_DAYLOG}"="yes" ] && [ ! -d "${OPT_USERCOUNT_LOGDIR}daylogs"  ] ; then
	mkdir ${OPT_USERCOUNT_LOGDIR}daylogs
	echo "${OPT_USERCOUNT_LOGDIR}daylogs created..."
fi
# fertig
colecho "opt_user-count...  complete..." gn


if [ "$OPT_USERCOUNT_DEBUG" = "yes"  ] ; then set +x ; fi
#set +x
