#!/bin/sh
#------------------------------------------------------------------------------
# main_User-Count.cgi - display logfiles of user costs during use wan
#
# Creation:     2003-01-13  alexrichter@gmx.net http://kickme.to/bhg
# last edit 24.06.2003
#
#------------------------------------------------------------------------------
#set -x

# html seite anfertigen
# var deklarieren
. /var/run/uc_hosts.cfg

zeit=`date +%f` # fr letzte verbindung
monat=`date +%m-%y` # fr log file benennung format :"01-03" fr januar 2003
uc_log_dir="${OPT_USERCOUNT_LOGDIR}" 
log_dest="${OPT_USERCOUNT_LOGDIR}uc_roh.log"
imondlog_dir="${IMOND_LOGDIR}"

echo "Content-Type: text/html; charset=iso-8859-1"
echo "Cache-control: no-store" # HTTP/1.1 (or no-cache?)
echo "Pragma: no-cache"        # HTTP/1.0
echo "Expires: `date -Ru`"     # Expires now!
echo
echo "<html><head>"
echo '<LINK REL=STYLESHEET TYPE="text/css" HREF="main.css">'
echo "<title>User Count Log Uebersicht</title>"
echo "</head><body>"

echo "<h4 align=center> Fli4l Opt User-Count Version 0.9 zeigt aktuell gelogte Verbindungen : </h4>"
echo "<p align=center>letzte Verbindung :<br><br>"

awk  ' BEGIN {	print "<align=center><table border=1 align=center cellspacing=2>" ;
		  	print "<tr bgcolor=\"#C0C0C0\"><th>Date</th><th>User</th><th>Prozent</th><th>Kosten</th><th>Zeit</th><tr>"  }
	{
		{ if( $5>=86400 ) 
			{ day=$5 / 86400 ; hour=(  $5 - int(day) * 86400 )  /  3600 ;
			 minuten=( $5 -int(day) * 86400 - int(hour) * 3600 )  / 60 ;
			sekunden=( $5 -int(day) * 86400 - int(hour) * 3600 - int(minuten) * 60 )
			zeit=int(day)"d"int(hour)"h"int(minuten)"m"int(sekunden)"s"  } 	
		else { if( $5>=3600 ) 
				{ hour=$5   /  3600 ; minuten=( $5  - int(hour) * 3600 )  / 60 ;
				sekunden=( $5 - int(hour) * 3600 - int(minuten) * 60 )  ; day=0 
				zeit=int(hour)"h"int(minuten)"m"int(sekunden)"s"  }	
			else { if( $5>=60 )
					{ minuten=$5   / 60 ; sekunden=( $5 - int(minuten) * 60 )  ;
				 	day=0 ; hour=0 
					zeit=int(minuten)"m"int(sekunden)"s" }	
				 else { if( $5>=1 )
				 		{ sekunden=$5 ;  day=0 ; hour=0 ; minuten=0 
						zeit=int(sekunden)"s" }
					 }
				}
			}		 	
		}	
	}	
		{ printf "<tr><td width=140>%-10s</td><td width=100 style=text-align:center>%10s</td>\
		<td width=80 style=text-align:right>%10.2f</td><td width=80 style=text-align:right>%10.2f</td><td width=100 style=text-align:right>%10s\</td><tr>\n",$1,$2,$3,$4,zeit	 } ' ${uc_log_dir}uc_main.log

echo "</table></p>"

# cgi-form for daylogauswertung
#debug OPT_USERCOUNT_DAYLOG="yes"
if [ "${OPT_USERCOUNT_DAYLOG}" = "yes" ] ; then

echo "<p align=center>individuellen Verbindungszeitraum ausw&auml;hlen :</p>"
echo "<table align=center border=0 cellspacing=0>"
echo "<tr><td><form name=\"daylog\" method=\"get\" action=\"uc_actions.cgi\">"
ls -1 ${uc_log_dir}daylogs/ | sort -n -t- -k2 -n -k1 | \
awk ' BEGIN	{ z=0 ; print "von :" ; print "<select name=\"from\" size=\"1\">" }
			{ z++ ; sub(".daylog","",$1) ; print "<option value=\""z"\">"$1"</option>" } 
	END		{ print "</select>" } '
	
ls -1 ${uc_log_dir}daylogs/ | sort -n -t- -k2 -n -k1 | \
awk ' BEGIN	{ z=0 ; print " bis einschlie&szlig;lich :" ; print "<select name=\"to\" size=\"1\">" }
			{ z++ ; sub(".daylog","",$1) ; print "<option value=\""z"\">"$1"</option>" } 
		END	{ print "</select>" 	
			 print "<input type=\"submit\" name=\"start_end\" value=\"ermitteln\">" ; print "</form>" } '	
echo "</td></tr></table>" 
fi

# monate
echo "<p align=center>Monats Verbindungen :</p>"

cd $uc_log_dir
for i in `ls | grep _uc.log | sort -nr -t- -k2` # absteigend sortieren, beginn mit aktuellen monat
 do
  awk -v monaktlog="$i"  '
   	BEGIN	{ split (monaktlog,monaktarray,"_") ; monakt=monaktarray[1]
     			print "<table align=center border=1 align=center cellspacing="2">"
     			print "<tr bgcolor=\"#C0C0C0\"><th>"monakt; print"Summe</th><th>Kosten</th><th>Zeit</th><tr>"
        		}
   	END {
     while ( getline < monaktlog )
     {
     		 { if( $3>=86400 ) 
			{ day=$3 / 86400 ; hour=(  $3 - int(day) * 86400 )  /  3600 ;
			 minuten=( $3 -int(day) * 86400 - int(hour) * 3600 )  / 60 ;
			sekunden=( $3 -int(day) * 86400 - int(hour) * 3600 - int(minuten) * 60 ) 
			zeit=int(day)"d"int(hour)"h"int(minuten)"m"int(sekunden)"s" } 	
		else { if( $3>=3600 ) 
				{ hour=$3   /  3600 ; minuten=( $3  - int(hour) * 3600 )  / 60 ;
				sekunden=( $3 - int(hour) * 3600 - int(minuten) * 60 )  ; day=0 
				zeit=int(hour)"h"int(minuten)"m"int(sekunden)"s" }	
			else { if( $3>=60 )
					{ minuten=$3   / 60 ; sekunden=( $3 - int(minuten) * 60 )  ;
				 	day=0 ; hour=0 
					zeit=int(minuten)"m"int(sekunden)"s" }	
				 else { if( $3>=1 )
				 		{ sekunden=$3 ;  day=0 ; hour=0 ; minuten=0 
						zeit=int(sekunden)"s" }
					 }
				}
			}		 	
		}	
      		{ printf "<tr><td width=140>%-10s</td><td width=100 style=text-align:right>%10.2f</td><td width=100 style=text-align:right>%10s</td><tr>",$1,$2,zeit }
      }
     print "</table><br>"
       		} ' $i
   # $i ist hier dummy fr awk
done


 
echo "<p align=center>letzte Erstellung : $zeit</p>"
echo "</body></html>"

#set +x
# ps : klingonen schreiben keine kommentare :-)
